/*
 * useradmin.c - Full-screen user administration program
 * see copyright.doc for copyright information
 * v1.1
 */

#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>
#include <curses.h>
#include "citadel.h"

long atol();
long lseek();

long finduser(file,name)
int file;
char name[];
{
	struct usersupp temp;
	int a;
	long bottom,top,guess,obottom,otop;

	obottom=(-1L); otop=(-1L);

	bottom=0L;
	top=(lseek(file,0L,2)/(long)sizeof(struct usersupp));

FPT:	if ((obottom==bottom)&&(otop==top)) {
		return(-1L); }
	obottom=bottom; otop=top;
	guess=(((top-bottom)/2)+bottom);
	lseek(file,(guess*(long)sizeof(struct usersupp)),0);
	read(file,&temp,sizeof(struct usersupp));
	a=strucmp(temp.fullname,name);
	if (a==0)
		return(lseek(file,(guess*(long)sizeof(struct usersupp)),0));
	if (a<0) {
		bottom=guess;
		goto FPT; }
	if (a>0) {
		top=guess;
		goto FPT; }
}

strucmp(st1,st2)
char st1[],st2[]; {
	char aaa[100],bbb[100];
	int a;
	strcpy(aaa,st1);
	strcpy(bbb,st2);
	for (a=0; a<strlen(aaa); ++a) aaa[a]=tolower(aaa[a]);
	for (a=0; a<strlen(bbb); ++a) bbb[a]=tolower(bbb[a]);
	a=strcmp(aaa,bbb);
	return(a);
}

main() {
	char user[100];
	long aa;
	int file,a;
	struct usersupp usersupp;
	
	chdir(BBSDIR);
	initscr();
	clear();
	printw("User Administration\n\nEnter user name: ");
	refresh();
	gets(user);

	file=open("usersupp",O_RDONLY);
	aa=finduser(file,user);
	if (aa<0L) {
		standout();
		printw("No such user.\n");
		standend(); refresh(); close(file); endwin();
		exit(1);
		}
	read(file,&usersupp,sizeof(struct usersupp));
	pwcrypt(usersupp.password,PWCRYPT);
	close(file);

	/* display user information */
	clear();
	move(1,0);
	printw("1. User name\n");
	printw("2. User number\n");
	printw("3. Uid attachment\n");
	printw("4. Password\n");
	printw("5. Screen width\n");
	printw("6. Times called\n");
	printw("7. Messages posted\n");
	printw("8. Last call\n");
	printw("9. Access level\n");
	for (a=10; a<=15; ++a) {
		move(a,0);
		printw("%d.\n",a);
		}
	for (a=1; a<=20; ++a) display_field(&usersupp,a);
	refresh();

	/* editing loop */
	while(1) {
		move(10,50); addstr("Enter field number to change");
		move(11,50); addstr("0 to exit");
		move(12,50); addstr("-1 to display registration");
		move(13,50); addstr("--> _____");
		refresh(); move(13,54); refresh();
		gets(user);
		refresh();
		a=atoi(user);
		if (a==0) break;
		if (a>0) edit_field(&usersupp,a);
		if (a<0) dis_regis(&usersupp);
		}

		move(22,0); addstr("Save changes (y/n)? ");
		refresh();
		gets(user);
		if (tolower(user[0])=='y') {
			file=open("usersupp",O_RDWR);
			aa=finduser(file,usersupp.fullname);
			pwcrypt(usersupp.password,PWCRYPT);
		      if (aa>=0L) write(file,&usersupp,sizeof(struct usersupp));
			close(file);
			}
	clear(); refresh();
	endwin();
	exit(0);
}

dis_regis(userdata)
struct usersupp *userdata; {
	struct registration regis;
	int a,b,file;
	char pbuf[20];
	if (!((userdata->flags)&US_REGIS)) {
		move(1,50); standout();
		addstr("No registration online");
		standend(); refresh();
		return(1);
		}
	file=open("registration",O_RDONLY);
	if (file<0) return(2);
	while(read(file,&regis,sizeof(struct registration))>0) {
		if (userdata->eternal==regis.RGeternal) {
			standout();
			move(1,50); printw("%-29s",regis.RGname);
			move(2,50); printw("%-29s",regis.RGaddr);
			move(3,50); printw("%-14s %2s %6s     ",
				regis.RGcity,regis.RGstate,regis.RGzip);
			strcpy(pbuf,regis.RGphone);
			regis.RGphone[0]=0;
			for (a=0; a<strlen(pbuf); ++a) {
				if ((pbuf[a]>='0')&&(pbuf[a]<='9')) {
					b=strlen(regis.RGphone);
					regis.RGphone[b]=pbuf[a];
					regis.RGphone[b+1]=0;
					}
				}
			while(strlen(regis.RGphone)<10) {
				strcpy(pbuf,regis.RGphone);
				strcpy(regis.RGphone," ");
				strcat(regis.RGphone,pbuf);
				}

			move(4,50);
			printw("(%c%c%c) %c%c%c-%c%c%c%c               ",
				regis.RGphone[0],regis.RGphone[1],
				regis.RGphone[2],regis.RGphone[3],
				regis.RGphone[4],regis.RGphone[5],
				regis.RGphone[6],regis.RGphone[7],
				regis.RGphone[8],regis.RGphone[9]);
			standend(); refresh();
			}
		if (userdata->eternal==regis.RGeternal) break;
		}
	close(file);
	return(0);
	}


display_field(userdata,fieldnum)
struct usersupp *userdata;
int fieldnum; {
	move(0,0); refresh();
	if (fieldnum<10) move(fieldnum,20);
		else move(fieldnum,5);
	refresh();
	switch(fieldnum) {
	case 1:		printw("%-30s",userdata->fullname);
			break;
	case 2:		printw("%-10ld",userdata->eternal);
			break;
	case 3:		printw("%-5d",userdata->USuid);
			break;
	case 4:		printw("%-20s",userdata->password);
			break;
	case 5:		printw("%-5d",userdata->screenwidth);
			break;
	case 6:		printw("%-5d",userdata->timescalled);
			break;
	case 7:		printw("%-5d",userdata->posted);
			break;
	case 8:		printw("%-20ld",userdata->lastcall);
			break;
	case 9:		printw("%1d",userdata->axlevel);
			break;
	case 10:	if (userdata->flags & US_PERM)
				addstr("Do not scroll off          ");
			else	addstr("Scroll off after two months");
			break;
	case 11:	if (userdata->flags & US_LASTOLD)
				addstr("Print last old message with new");
			else	addstr("Do not print last old message  ");
			break;
	case 12:	if (userdata->flags & US_EXPERT)
				addstr("Experienced user: suppress hints");
			else	addstr("Print help blurbs and hints     ");
			break;
	case 13:	if (userdata->flags & US_UNLISTED)
				addstr("Do not list in userlog");
			else	addstr("List in userlog       ");
			break;
	case 14:	if (userdata->flags & US_NOPROMPT)
				addstr("Do not prompt after each message");
			else	addstr("Prompt after each message       ");
			break;
	case 15:	if (userdata->flags & US_REGIS)
				addstr("Registered with name and address ");
			else	addstr("Not registered                   ");
			break;
	default:	break;
	}
	refresh();
	return(0);
	}

edit_field(userdata,fieldnum)
struct usersupp *userdata;
int fieldnum; {
	char new[100];
	if (fieldnum<10) { 
		move(fieldnum,20);
		addstr("                                               ");
		move(fieldnum,20);
		refresh();
		}
	switch(fieldnum) {
	case 2:		gets(new);
			userdata->eternal=atol(new);
			break;
	case 3:		gets(new);
			userdata->USuid=atol(new);
			break;
	case 4:		gets(userdata->password);
			break;
	case 5:		gets(new);
			userdata->screenwidth=atoi(new);
			break;
	case 6:		gets(new);
			userdata->timescalled=atoi(new);
			break;
	case 7:		gets(new);
			userdata->posted=atoi(new);
			break;
	case 8:		time(&userdata->lastcall);
			break;
	case 9:		gets(new);
			userdata->axlevel=atoi(new);
			break;
	case 10:	userdata->flags=(userdata->flags^US_PERM);
			break;
	case 11:	userdata->flags=(userdata->flags^US_LASTOLD);
			break;
	case 12:	userdata->flags=(userdata->flags^US_EXPERT);
			break;
	case 13:	userdata->flags=(userdata->flags^US_UNLISTED);
			break;
	case 14:	userdata->flags=(userdata->flags^US_NOPROMPT);
			break;
	case 15:	userdata->flags=(userdata->flags^US_REGIS);
			break;
	default:	break;
		}
	display_field(userdata,fieldnum);
	return(0);
}


pwcrypt(text,code)
char text[];
int code; {
	int a;
	for (a=0; a<strlen(text); ++a) text[a]=(text[a]^(((code|128)^a)&0xFF));
	return(0);
	}
